Index: account.c
===================================================================
--- account.c	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ account.c	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -182,17 +182,15 @@
 	account_t *a, *l = NULL;
 	
+	if( acc->ic )
+		/* Caller should have checked, accounts still in use can't be deleted. */
+		return;
+	
 	for( a = irc->accounts; a; a = (l=a)->next )
 		if( a == acc )
 		{
-			if( a->ic ) return; /* Caller should have checked, accounts still in use can't be deleted. */
-			
 			if( l )
-			{
 				l->next = a->next;
-			}
 			else
-			{
 				irc->accounts = a->next;
-			}
 			
 			while( a->set )
@@ -203,5 +201,5 @@
 			g_free( a->user );
 			g_free( a->pass );
-			if( a->server ) g_free( a->server );
+			g_free( a->server );
 			if( a->reconnect )	/* This prevents any reconnect still queued to happen */
 				cancel_auto_reconnect( a );
Index: bitlbee.conf
===================================================================
--- bitlbee.conf	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ bitlbee.conf	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -49,6 +49,11 @@
 ##
 ## Password the user should enter when logging into a closed BitlBee server.
+## You can also have an MD5-encrypted password here. Format: "md5:", followed
+## by a hash as generated for the <user password=""> attribute in a BitlBee
+## XML file (for now there's no easier way to generate the hash).
 ##
 # AuthPassword = ItllBeBitlBee   ## Heh.. Our slogan. ;-)
+## or
+# AuthPassword = md5:gzkK0Ox/1xh+1XTsQjXxBJ571Vgl
 
 ## OperPassword
@@ -57,4 +62,6 @@
 ##
 # OperPassword = ChangeMe!
+## or
+# OperPassword = md5:I0mnZbn1t4R731zzRdDN2/pK7lRX
 
 ## HostName
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ bitlbee.h	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -30,8 +30,8 @@
 
 #define PACKAGE "BitlBee"
-#define BITLBEE_VERSION "1.1.1dev"
+#define BITLBEE_VERSION "1.2"
 #define VERSION BITLBEE_VERSION
 
-#define MAX_STRING 128
+#define MAX_STRING 511
 
 #if HAVE_CONFIG_H
Index: conf.c
===================================================================
--- conf.c	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ conf.c	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -252,5 +252,5 @@
 			{
 				g_strfreev( conf->migrate_storage );
-				conf->migrate_storage = g_strsplit( ini->value, " \t,;", -1 );
+				conf->migrate_storage = g_strsplit_set( ini->value, " \t,;", -1 );
 			}
 			else if( g_strcasecmp( ini->key, "pinginterval" ) == 0 )
Index: debian/README.Debian
===================================================================
--- debian/README.Debian	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/README.Debian	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -1,5 +1,5 @@
-                   *** NEWS (Version 1.1 and later) ***
+                   *** NEWS (Version 1.2 and later) ***
 
-Starting from version 1.1, BitlBee has a forking daemon mode. The Debian
+Starting from version 1.2, BitlBee has a forking daemon mode. The Debian
 package now uses this mode by default, instead of inetd mode. If you don't
 want to use this, you can disable the init scripts (best way to do this is
@@ -7,5 +7,19 @@
 should be necessary only once, it won't be touched during upgrades.
 
---------------------------------------------------------------------------
+Another important change in BitlBee 1.2 is the file format used for your
+personal settings. Everything's now saved in a single .xml (per account,
+of course) file instead of $nick.accounts and $nick.nicks. One advantage
+of this new format is that the passwords are actually encrypted instead of
+just vaguely obfuscated. BitlBee can still read the old files, and will
+save things in the new format when you save/disconnect. After that, you
+can safely remove the old-style files (this is recommended).
+
+I tried making this transition (the new file format but especially, in this
+case, the inetd->forkdaemon mode change) as smooth as possible, but I'm
+aware that many BitlBee users will have their own hacks already to run the
+program. I hope the package won't break any of this for anyone. 1.2-2
+should fix at least some of the issues.
+
+---------------------------------------------------------------------------
 
 Debconf should have asked you on what port you want BitlBee to run. If it
Index: debian/bitlbee.init
===================================================================
--- debian/bitlbee.init	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/bitlbee.init	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -1,3 +1,10 @@
 #! /bin/sh
+### BEGIN INIT INFO
+# Provides:          bitlbee
+# Required-Start:    $remote_fs $syslog
+# Required-Stop:     $remote_fs $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      1
+### END INIT INFO
 #
 # Init script for BitlBee Debian package. Based on skeleton init script:
@@ -18,5 +25,5 @@
 # Default value
 BITLBEE_PORT=6667
-DAEMON_OPT=-F
+BITLBEE_OPTS=-F
 
 # Read config file if it is present.
@@ -37,6 +44,6 @@
 	
 	start-stop-daemon --start --quiet --pidfile $PIDFILE \
-		-c bitlbee -g nogroup \
-		--exec $DAEMON -- -p $BITLBEE_PORT -P $PIDFILE $DAEMON_OPT
+		-c bitlbee: \
+		--exec $DAEMON -- -p $BITLBEE_PORT -P $PIDFILE $BITLBEE_OPTS
 }
 
Index: debian/changelog
===================================================================
--- debian/changelog	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/changelog	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -1,11 +1,60 @@
-bitlbee (1.1.1dev-0pre) unstable; urgency=low
-
+bitlbee (1.2-4) unstable; urgency=low
+
+  * Not a real release, just a placeholder for the changelog.
+  * Fixed init script to use the BITLBEE_OPTS variable, not an undefined
+    DAEMON_OPT.
+  * Added dependency information to the init script. (Closes: #472567)
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Sat, 29 Mar 2008 21:10:33 +0000
+
+bitlbee (1.2-3) unstable; urgency=low
+
+  * Removed DEB_BUILD_OPTIONS again (forgot to apply that change to the 1.2
+    branch when I finished 1.0.4-2, things diverged too much anyway.)
+    Closes: #472540.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Mon, 24 Mar 2008 21:10:14 +0000
+
+bitlbee (1.2-2) unstable; urgency=low
+
+  * Fixed some packaging issues reported by IRC and e-mail. (Closes: #472373)
+  * Fixed proxy support. (Closes: #472395)
+  * Added a BitlBee group so only root can edit the configs and BitlBee can
+    just *read* it.
+  * Manually deleting /var/lib/bitlbee/ when purging, deluser doesn't want to
+    do it.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Mon, 24 Mar 2008 19:48:24 +0000
+
+bitlbee (1.2-1) unstable; urgency=low
+
+  * New upstream release. (Closes: #325017, #386914, #437515)
+  * With hopefully completely sane charset handling (Closes: #296145)
   * Switched to the new forking daemon mode. Added /etc/default/bitlbee
     file, an init script. People who want to stick with inetd can do so, see
     the defaults file.
+    (Closes: #460741, #466171, #294585, #345038, #306452, #392682)
   * Got rid of debconf Woody compatibility stuff.
   * No more MPL code in BitlBee, thanks to the Jabber module rewrite!
-
- -- Wilmer van der Gaast <wilmer@gaast.net>  Fri, 06 Jul 2007 09:09:36 +0100
+  * Added Italian translation, sorry for taking so long! (Closes: #448238)
+  * Added libevent dependency (more reliable event handling).
+  * Removed GLib 1.x dependency because BitlBee really requires GLib >=2.4.
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Tue, 18 Mar 2008 23:44:19 +0000
+
+bitlbee (1.0.4-2) unstable; urgency=low
+
+  * Removed $DEB_BUILD_OPTIONS because apparently buildds fill it with crap.
+    (Closes: #458717)
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Mon, 11 Feb 2008 19:15:33 +0000
+
+bitlbee (1.0.4-1) unstable; urgency=low
+
+  * New upstream release.
+  * Changed libnss-dev dependency. (Closes: #370442)
+  * Added build-indep rule to debian/rules. (Closes: #395673)
+
+ -- Wilmer van der Gaast <wilmer@gaast.net>  Wed, 29 Aug 2007 20:24:28 +0100
 
 bitlbee (1.0.3-1.3) unstable; urgency=low
Index: debian/conffiles
===================================================================
--- debian/conffiles	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/conffiles	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -1,2 +1,3 @@
 /etc/bitlbee/motd.txt
 /etc/bitlbee/bitlbee.conf
+/etc/init.d/bitlbee
Index: debian/control
===================================================================
--- debian/control	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/control	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -4,5 +4,5 @@
 Maintainer: Wilmer van der Gaast <wilmer@gaast.net>
 Standards-Version: 3.5.9
-Build-Depends: libglib2.0-dev | libglib-dev, libgnutls-dev | libnss-dev (>= 1.6), debconf-2.0, po-debconf
+Build-Depends: libglib2.0-dev (>= 2.4), libevent-dev, libgnutls-dev | libnss-dev (>= 1.6), debconf-2.0, po-debconf
 
 Package: bitlbee
Index: debian/postinst
===================================================================
--- debian/postinst	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/postinst	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -14,9 +14,18 @@
 BITLBEE_DISABLED=0
 BITLBEE_UPGRADE_DONT_RESTART=0
-[ -r /etc/default/bitlbee ] && source /etc/default/bitlbee
+[ -r /etc/default/bitlbee ] && . /etc/default/bitlbee
 
-if [ "$BITLBEE_DISABLED" = "0" ]; then
-	## In case it's still there (if we're upgrading right now)
+if [ "$BITLBEE_DISABLED" = "0" ] && type update-inetd > /dev/null 2> /dev/null &&
+   ( expr "$2" : '0\..*' > /dev/null || expr "$2" : '1\.0\..*' > /dev/null ); then
+	## Make sure the inetd entry is gone (can still be there from a
+	## previous version.
 	update-inetd --remove '.*/usr/sbin/bitlbee'
+	if grep -q /usr/sbin/bitlbee /etc/inetd.conf 2> /dev/null; then
+		# Thanks for breaking update-inetd! (bugs.debian.org/311111)
+		# I hope that it works at least with xinetd, because this
+		# emergency hack doesn't:
+		perl -pi -e 's:^[^#].*/usr/sbin/bitlbee$:## Now using daemon mode\: # $&:' /etc/inetd.conf
+		killall -HUP inetd || true
+	fi
 fi
 
@@ -65,11 +74,19 @@
 fi
 
-adduser --system --home /var/lib/bitlbee/ --disabled-login --disabled-password bitlbee
+adduser --system --group --disabled-login --disabled-password --home /var/lib/bitlbee/ bitlbee
 chmod 700 /var/lib/bitlbee/
 
 ## Can't do this in packaging phase: Don't know the UID yet. Access to
-## the file should be limited, now that it stores passwords.
-chmod 600 /etc/bitlbee/bitlbee.conf
-chown bitlbee /etc/bitlbee/bitlbee.conf
+## the file should be limited, now that it stores passwords. Added
+## --group later for a little more security, but have to see if I can
+## apply this change to existing installations on upgrades. Will think
+## about that later.
+if getent group bitlbee > /dev/null; then
+	chmod 640 /etc/bitlbee/bitlbee.conf
+	chown root:bitlbee /etc/bitlbee/bitlbee.conf
+else
+	chmod 600 /etc/bitlbee/bitlbee.conf
+	chown bitlbee /etc/bitlbee/bitlbee.conf
+fi
 
 if [ -z "$2" ]; then
Index: debian/postrm
===================================================================
--- debian/postrm	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/postrm	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -9,3 +9,6 @@
 
 update-rc.d bitlbee remove > /dev/null 2>&1 || true
-deluser --remove-home bitlbee || true
+rm -f /etc/default/bitlbee
+
+deluser --system --remove-home bitlbee || true
+rm -rf /var/lib/bitlbee ## deluser doesn't seem to do this for homedirs in /var
Index: debian/rules
===================================================================
--- debian/rules	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ debian/rules	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -3,13 +3,16 @@
 DEBUG ?= 0
 
+ifdef BITLBEE_VERSION
+BITLBEE_FORCE_VERSION=1
+else
 # Want to use the full package version number instead of just the release.
 BITLBEE_VERSION ?= "$(shell dpkg-parsechangelog | grep ^Version: | awk '{print $$2}')"
 export BITLBEE_VERSION
-
+endif
 
 build-arch: build-arch-stamp
 build-arch-stamp:
 	if [ ! -d debian ]; then exit 1; fi
-	./configure --debug=$(DEBUG) --prefix=/usr --etcdir=/etc/bitlbee $(DEB_BUILD_OPTIONS)
+	./configure --debug=$(DEBUG) --prefix=/usr --etcdir=/etc/bitlbee --events=libevent
 	$(MAKE)
 #	$(MAKE) -C doc/ all
@@ -66,5 +69,5 @@
 		find usr -type f -exec md5sum {} \; > DEBIAN/md5sums
 	dpkg-shlibdeps -Tdebian/bitlbee.substvars -dDepends debian/bitlbee/usr/sbin/bitlbee
-ifdef BITLBEE_VERSION
+ifdef BITLBEE_FORCE_VERSION
 	dpkg-gencontrol -ldebian/changelog -isp -pbitlbee -Tdebian/bitlbee.substvars -Pdebian/bitlbee -v1:$(BITLBEE_VERSION)-0 -V'debconf-depends=debconf (>= 1.2.0) | debconf-2.0'
 else
Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ doc/CHANGES	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -1,6 +1,17 @@
+Version 1.2.1:
+- Fixed proxy support.
+- Fixed stalling issues while connecting to Jabber when using the OpenSSL
+  module.
+- Fixed problem with GLib and ForkDaemon where processes didn't die when
+  the client disconnects.
+- Fixed handling of "set charset none". (Which pretty much breaks the account
+  completely in 1.2.)
+- You can now automatically identify yourself to BitlBee by setting a server
+  password in your IRC client.
+- Compatible with all crazy kinds of line endings that clients can send.
+
+Finished ...
+
 Version 1.2:
-- First BitlBee development/testing RELEASE. This should be quite stable
-  though (and for most people more stable than 1.0.x). It just has a couple
-  of rough edges and needs a bit more testing.
 - Added ForkDaemon mode next to the existing Daemon- and inetd modes. With
   ForkDaemon you can run BitlBee as a stand-alone daemon and every connection
@@ -21,7 +32,16 @@
   1.x is so old that supporting it really isn't necessary anymore.
 - Many, many, MANY little changes, improvements, fixes. Using non-blocking
-  I/O as much as possible, fixed lots of little bugs (including bugs that
-  affected daemon mode stability). See the bzr logs for more information.
-- Added units tests, will have to add some more before the real release.
+  I/O as much as possible, replaced the Gaim (0.59, IOW heavily outdated)
+  API, fixed lots of little bugs (including bugs that affected daemon mode
+  stability). See the bzr logs for more information.
+- One of the user-visible changes from the API change: You can finally see
+  all away states/messages properly.
+- Added units tests. Test coverage is very minimal for now.
+- Better charset handling: Everything is just converted from/to UTF-8 right
+  in the IRC core, and charset mismatches are detected (if possible) and the
+  user is asked to resolve this before continuing. Also, UTF-8 is the default
+  setting now, since that's how the world seems to work these days.
+- One can now keep hashed passwords in bitlbee.conf instead of the cleartext
+  version.
 - Most important change: New file format for user data (accounts, nicks and
   settings). Migration to the new format should happen transparently,
@@ -69,6 +89,11 @@
   * An XML console (add xmlconsole to your contact list or see "help set
     xmlconsole" if you want it permanently).
-
-Finished ???
+- The Yahoo! module now says it supports YMSG protocol version 12, which will
+  hopefully keep the Yahoo module working after 2008-04-02 (when Yahoo! is
+  dropping support for version 6.x of their client).
+- MSN switchboard handling changes. Hopefully less messages will get lost now,
+  although things are still not perfect.
+
+Finished 17 Mar 2008
 
 Version 1.0.4:
Index: doc/README
===================================================================
--- doc/README	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ doc/README	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -41,4 +41,18 @@
 by default) and chown it to the UID BitlBee is running as. Make sure this
 directory is read-/writable by this user only.
+
+--- (Fork)Daemon mode
+
+If you don't want to run any inetd daemon, you can run BitlBee in Daemon
+mode. Right now, daemon mode may be a bad idea on servers with multiple
+users, since possible fatal BitlBee bugs will crash the BitlBee process and
+disconnect all connected users at once. Instead, you can use ForkDaemon
+mode, which serves every user from a separate process, without depending on
+an inetd daemon.
+
+To use BitlBee in daemon mode, just start it with the right flags or enable
+it in bitlbee.conf. You probably want to write an init script to start
+BitlBee automatically after a reboot. (This is where you realise using
+a package from your distro would've been a better idea. :-P)
 
 
Index: ipc.c
===================================================================
--- ipc.c	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ ipc.c	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -258,128 +258,121 @@
 	else
 	{
+		ipc_master_free_fd( source );
+	}
+	
+	return TRUE;
+}
+
+gboolean ipc_child_read( gpointer data, gint source, b_input_condition cond )
+{
+	char *buf, **cmd;
+	
+	if( ( buf = ipc_readline( source ) ) )
+	{
+		cmd = irc_parse_line( buf );
+		if( cmd )
+			ipc_command_exec( data, cmd, ipc_child_commands );
+	}
+	else
+	{
+		ipc_child_disable();
+	}
+	
+	return TRUE;
+}
+
+void ipc_to_master( char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		char *s = irc_build_line( cmd );
+		ipc_to_master_str( "%s", s );
+		g_free( s );
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		ipc_command_exec( NULL, cmd, ipc_master_commands );
+	}
+}
+
+void ipc_to_master_str( char *format, ... )
+{
+	char *msg_buf;
+	va_list params;
+
+	va_start( params, format );
+	msg_buf = g_strdup_vprintf( format, params );
+	va_end( params );
+	
+	if( strlen( msg_buf ) > 512 )
+	{
+		/* Don't send it, it's too long... */
+	}
+	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		if( global.listen_socket >= 0 )
+			if( write( global.listen_socket, msg_buf, strlen( msg_buf ) ) <= 0 )
+				ipc_child_disable();
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
+		char **cmd, *s;
+		
+		if( ( s = strchr( msg_buf, '\r' ) ) )
+			*s = 0;
+		
+		cmd = irc_parse_line( msg_buf );
+		ipc_command_exec( NULL, cmd, ipc_master_commands );
+		g_free( cmd );
+	}
+	
+	g_free( msg_buf );
+}
+
+void ipc_to_children( char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		char *msg_buf = irc_build_line( cmd );
+		ipc_to_children_str( "%s", msg_buf );
+		g_free( msg_buf );
+	}
+	else if( global.conf->runmode == RUNMODE_DAEMON )
+	{
 		GSList *l;
-		struct bitlbee_child *c;
-		
-		for( l = child_list; l; l = l->next )
+		
+		for( l = irc_connection_list; l; l = l->next )
+			ipc_command_exec( l->data, cmd, ipc_child_commands );
+	}
+}
+
+void ipc_to_children_str( char *format, ... )
+{
+	char *msg_buf;
+	va_list params;
+
+	va_start( params, format );
+	msg_buf = g_strdup_vprintf( format, params );
+	va_end( params );
+	
+	if( strlen( msg_buf ) > 512 )
+	{
+		/* Don't send it, it's too long... */
+	}
+	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
+	{
+		int msg_len = strlen( msg_buf );
+		GSList *l, *next;
+		
+		for( l = child_list; l; l = next )
 		{
-			c = l->data;
-			if( c->ipc_fd == source )
+			struct bitlbee_child *c = l->data;
+			
+			next = l->next;
+			if( write( c->ipc_fd, msg_buf, msg_len ) <= 0 )
 			{
 				ipc_master_free_one( c );
 				child_list = g_slist_remove( child_list, c );
-				break;
 			}
-		}
-	}
-	
-	return TRUE;
-}
-
-gboolean ipc_child_read( gpointer data, gint source, b_input_condition cond )
-{
-	char *buf, **cmd;
-	
-	if( ( buf = ipc_readline( source ) ) )
-	{
-		cmd = irc_parse_line( buf );
-		if( cmd )
-			ipc_command_exec( data, cmd, ipc_child_commands );
-	}
-	else
-	{
-		b_event_remove( global.listen_watch_source_id );
-		close( global.listen_socket );
-		
-		global.listen_socket = -1;
-	}
-	
-	return TRUE;
-}
-
-void ipc_to_master( char **cmd )
-{
-	if( global.conf->runmode == RUNMODE_FORKDAEMON )
-	{
-		char *s = irc_build_line( cmd );
-		ipc_to_master_str( "%s", s );
-		g_free( s );
-	}
-	else if( global.conf->runmode == RUNMODE_DAEMON )
-	{
-		ipc_command_exec( NULL, cmd, ipc_master_commands );
-	}
-}
-
-void ipc_to_master_str( char *format, ... )
-{
-	char *msg_buf;
-	va_list params;
-
-	va_start( params, format );
-	msg_buf = g_strdup_vprintf( format, params );
-	va_end( params );
-	
-	if( strlen( msg_buf ) > 512 )
-	{
-		/* Don't send it, it's too long... */
-	}
-	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
-	{
-		write( global.listen_socket, msg_buf, strlen( msg_buf ) );
-	}
-	else if( global.conf->runmode == RUNMODE_DAEMON )
-	{
-		char **cmd, *s;
-		
-		if( ( s = strchr( msg_buf, '\r' ) ) )
-			*s = 0;
-		
-		cmd = irc_parse_line( msg_buf );
-		ipc_command_exec( NULL, cmd, ipc_master_commands );
-		g_free( cmd );
-	}
-	
-	g_free( msg_buf );
-}
-
-void ipc_to_children( char **cmd )
-{
-	if( global.conf->runmode == RUNMODE_FORKDAEMON )
-	{
-		char *msg_buf = irc_build_line( cmd );
-		ipc_to_children_str( "%s", msg_buf );
-		g_free( msg_buf );
-	}
-	else if( global.conf->runmode == RUNMODE_DAEMON )
-	{
-		GSList *l;
-		
-		for( l = irc_connection_list; l; l = l->next )
-			ipc_command_exec( l->data, cmd, ipc_child_commands );
-	}
-}
-
-void ipc_to_children_str( char *format, ... )
-{
-	char *msg_buf;
-	va_list params;
-
-	va_start( params, format );
-	msg_buf = g_strdup_vprintf( format, params );
-	va_end( params );
-	
-	if( strlen( msg_buf ) > 512 )
-	{
-		/* Don't send it, it's too long... */
-	}
-	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
-	{
-		int msg_len = strlen( msg_buf );
-		GSList *l;
-		
-		for( l = child_list; l; l = l->next )
-		{
-			struct bitlbee_child *c = l->data;
-			write( c->ipc_fd, msg_buf, msg_len );
 		}
 	}
@@ -410,4 +403,21 @@
 }
 
+void ipc_master_free_fd( int fd )
+{
+	GSList *l;
+	struct bitlbee_child *c;
+	
+	for( l = child_list; l; l = l->next )
+	{
+		c = l->data;
+		if( c->ipc_fd == fd )
+		{
+			ipc_master_free_one( c );
+			child_list = g_slist_remove( child_list, c );
+			break;
+		}
+	}
+}
+
 void ipc_master_free_all()
 {
@@ -419,4 +429,12 @@
 	g_slist_free( child_list );
 	child_list = NULL;
+}
+
+void ipc_child_disable()
+{
+	b_event_remove( global.listen_watch_source_id );
+	close( global.listen_socket );
+	
+	global.listen_socket = -1;
 }
 
Index: ipc.h
===================================================================
--- ipc.h	(revision 0db75ad966458610427dacdd31ecbaddbca18935)
+++ ipc.h	(revision dd345753c1742905c9f81aa71d8b09109fbc5456)
@@ -44,5 +44,8 @@
 
 void ipc_master_free_one( struct bitlbee_child *child );
+void ipc_master_free_fd( int fd );
 void ipc_master_free_all();
+
+void ipc_child_disable();
 
 void ipc_to_master( char **cmd );
